# 前言

`Luban`是图片压缩工具，通过参考或者自创压缩规则推求极致的压缩效果
目前的版本压缩效果主要参考微信。因为微信用户量最大，如果压缩后的图片越接近微信则越被用户接受。

# 说明

目前的`Luban`只是压缩结果接近微信，自身的算法只是为了达到这个效果而设计的。与微信并无任何联系，也不敢妄称是微信的算法。

# 算法步骤

注：下文所说“比例”统一表示：图片短边除以长边为该图片比例

## 第三挡压缩（参考最新版微信压缩效果）

1. 判断图片比例值，是否处于以下区间内；
  - [1, 0.5625)    即图片处于 [1:1 ~ 9:16) 比例范围内
  - [0.5625, 0.5)  即图片处于 [9:16 ~ 1:2) 比例范围内
  - [0.5, 0)       即图片处于 [1:2 ~ 1:∞) 比例范围内
2. 判断图片最长边是否过边界值；
  - [1, 0.5625)   边界值为：1664 * n（n=1）, 4990 * n（n=2）, 1280 * pow(2, n-1)（n≥3）
  - [0.5625, 0.5) 边界值为：1280 * pow(2, n-1)（n≥1）
  - [0.5, 0)      边界值为：1280 * pow(2, n-1)（n≥1）
3. 计算压缩图片实际边长值，以第2步计算结果为准，超过某个边界值则：width / pow(2, n-1)，height/pow(2, n-1)
4. 计算压缩图片的实际文件大小，以第2、3步结果为准，图片比例越大则文件越大。  
    size = (newW * newH) / (width * height) * m；
  - [1, 0.5625) 则 width & height 对应 1664，4990，1280 * n（n≥3），m 对应 150，300，300；
  - [0.5625, 0.5) 则 width = 1440，height = 2560, m = 200；
  - [0.5, 0) 则 width = 1280，height = 1280 / scale，m = 500；注：scale为比例值
5. 判断第4步的size是否过小
  - [1, 0.5625) 则最小 size 对应 60，60，100
  - [0.5625, 0.5) 则最小 size 都为 100
  - [0.5, 0) 则最小 size 都为 100
6. 将前面求到的值压缩图片 width, height, size 传入压缩流程，压缩图片直到满足以上数值
